Subject: Re: linux-next: manual merge of the ptrace tree with the s390 tree

From: Oleg Nesterov <[email-masked]>
Date: Thu, 21 Jul 2011 16:44:47 +0200

On 07/21, Tejun Heo wrote:
>
>
> On Wed, Jul 20, 2011 at 03:33:20PM +1000, Stephen Rothwell wrote:
> > Today's linux-next merge of the ptrace tree got a conflict in
> > arch/s390/kernel/traps.c between commit 248bed4b0f3c ("[S390] use siginfo
> > for sigtrap signals") from the s390 tree and commit a288eecce525
> > ("ptrace: kill trivial tracehooks") from the ptrace tree.
> >
> > It looks like the former is a superset of the latter, so I used the
> > former.
>
> Yeap, pretty much.  Martin, testing if (current->ptrace) is enough.
> If PT_PTRACED is not set, no other flag there is allowed to set.

Agreed,

> Also, I think we really should standardize what gets reported in these
> debug traps instead of letting each arch do its own thing.

May be we can standardize .si_info within the single arch at least ;)

I never understood what TRAP_HWBKPT/TRAP_BRKPT actually means, and
I can be easily wrong. But, afaics, on x86 PTRACE_SINGLESTEP results
in TRAP_TRACE. Unless the tracee steps over syscall, in this case
user_single_step_siginfo() sets TRAP_BRKPT. Hmm.

And unless I misread 248bed4b0f3c s390 thinks we need TRAP_HWBKPT.

Oleg.